var path = require('path'),
	fs = require('fs'),
    colors = require('colors'),
    del = require('del');

/**
 * @desc Deletes file or returns to caller to continue traversing.
 * @param {string} fileName - Path to file or folder 
*/
function fileType(fileName, dir) {
    console.log('Deleting: ' + fileName.yellow);
    if (fileName) {
        fs.stat(fileName, function(err, stat) {
            if (stat && stat.isFile()) {
                if (del(dir)) {
                    var success = '| ---------------------------- FINISHING UP... ---------------------------- |';
                    console.log(success.green);
                }
            } else if (stat && stat.isDirectory()) {
                return false;
            } else {
                return err;
            }
        });
    }
}

/**
 * @desc Recursively deletes node_modules folder for Windows developers.
 * @param {string} dir - Path to node_modules folder
*/
var cleanup = function(dir) {
    fs.readdir(dir, function doneReading(err, files) {
        if (err) {
            return err;
        }

        for (var i = 0; i <= files.length; i++) {
            if (typeof files[i] === 'string' || files[i] instanceof String) {
                if (files[i] !== 'del') {

                    dir = dir + path.sep + files[i];

                    if (!fileType(dir, dir)) {
                        return cleanup(dir);
                    }
                }
            }
        }
    });
}

exports.cleanup = cleanup;